#############################################################################
##  
##  PackageInfo.g for the package `PNQPORC'                      Bettina Eick
##                                                               Tobias Moede

SetPackageInfo( rec(
PackageName := "pnqporc",
Subtitle := "PORC polynomials describing the number of groups of order p^nq, for p,q different primes and n <= 5",
Version := "1.1",
Date := "04/26/2021",

## <#GAPDoc Label="PKGVERSIONDATA">
##	<!ENTITY VERSION "1.1">
##	<!ENTITY RELEASEDATE "04/26/2021">
## <#/GAPDoc>

PackageWWWHome := "http://www.icm.tu-bs.de/~tobmoede/pnq/",
ArchiveURL := Concatenation( ~.PackageWWWHome, "pnqporc-", ~.Version ),
ArchiveFormats := ".tar.gz",

Persons := [
  rec( 
    LastName      := "Eick",
    FirstNames    := "Bettina",
    IsAuthor      := true,
    IsMaintainer  := false,
    Email         := "beick@tu-bs.de",
    WWWHome       := "http://www.icm.tu-bs.de/~beick/",
    PostalAddress := Concatenation( [
                       "Institut Computational Mathematics\n",
                       "Universitaetsplatz 2, 38106 Braunschweig\n",
                       "Germany" ] ),
    Place         := "Braunschweig",
    Institution   := "TU Braunschweig"
  ),
  rec( 
    LastName      := "Moede",
    FirstNames    := "Tobias",
    IsAuthor      := true,
    IsMaintainer  := true,
    Email         := "t.moede@tu-bs.de",
    WWWHome       := "http://www.icm.tu-bs.de/~tobmoede/",
    PostalAddress := Concatenation( [
                       "Institut Computational Mathematics\n",
                       "Universitaetsplatz 2, 38106 Braunschweig\n",
                       "Germany" ] ),
    Place         := "Braunschweig",
    Institution   := "TU Braunschweig"
  ),
],

Status := "dev",

README_URL := 
  Concatenation( ~.PackageWWWHome, "README" ),
PackageInfoURL := 
  Concatenation( ~.PackageWWWHome, "PackageInfo.g" ),

AbstractHTML := 
  "The <span class=\"pkgname\">pnqporc</span> package contains PORC polynomials \
   describing the number of isomorphism types of groups of order p^nq, where p,q \
   are different primes and n <= 5.",

PackageDoc := rec(         
  BookName  := "pnqporc",
  ArchiveURLSubset := ["doc"],
  HTMLStart := "doc/chap0.html",
  PDFFile   := "doc/manual.pdf",
  SixFile   := "doc/manual.six",
  LongTitle := "PORC polynomials for groups of order p^nq",
),

Dependencies := rec(
  GAP := ">=4.4",
  NeededOtherPackages := [["liepring", ">=1.9.2"]],
  SuggestedOtherPackages := [],
  ExternalConditions := []                      
),

BannerString := Concatenation( "Loading pnqporc ", ~.Version, "... \n"),
AvailabilityTest := ReturnTrue,
Autoload := false,
));

