#############################################################################
##
## NumberPNQ(n) determines the number of isomorphism types of groups of order
## p^nq for q <> p and n <= 5.
##
InstallMethod( NumberPNQ, [IsPosInt], function( n )
	if not n in [1..5] then
		Error("n must be an integer between 1 and 5!");
	fi;

    return NumberPNQNilpotent(n) + NumberPNQNormalPSylow(n) + + NumberPNQNormalQSylow(n) + NumberPNQExceptional(n);
end );
