#############################################################################
##
## Values for all deltas and gammas
##
Val := function( D, P, Q )
    if D = Q13 then
        if Q = 13 then return 1; fi;
    elif D = Q5 then
        if Q = 5 then return 1; fi;
    elif D = Q3 then
        if Q = 3 then return 1; fi;
    elif D = Q2 then
        if Q = 2 then return 1; fi;
    elif D = P3 then
        if P = 3 then return 1; fi;
    elif D = P2 then
        if P = 2 then return 1; fi;
    elif D = D1 then
        if IsInt((P-1)/Q) then return 1; fi;
    elif D = D2 then
        if IsInt((P^2-1)/Q) and not IsInt((P-1)/Q) then return 1; fi;
    elif D = D3 then
        if IsInt((P^3-1)/Q) and not IsInt((P^2-1)/Q)
                            and not IsInt((P-1)/Q) then return 1; fi;
    elif D = D4 then
        if IsInt((P^4-1)/Q) and not IsInt((P^3-1)/Q)
                            and not IsInt((P^2-1)/Q)
                            and not IsInt((P-1)/Q) then return 1; fi;
    elif D = D5 then
        if IsInt((P^5-1)/Q) and not IsInt((P^4-1)/Q)
                            and not IsInt((P^3-1)/Q)
                            and not IsInt((P^2-1)/Q)
                            and not IsInt((P-1)/Q) then return 1; fi;
    elif D = D6 then
        if IsInt((Q-1)/3) then return 1; fi;
    elif D = D7 then
        if IsInt((Q-1)/4) then return 1; fi;
    elif D = D8 then
        if IsInt((Q-1)/5) then return 1; fi;
    elif D = D9 then
        if IsInt((P-1)/3) then return 1; fi;
    elif D = D10 then
        if IsInt((P-1)/4) then return 1; fi;
    elif D = D11 then
        if IsInt((P-1)/2) then return 1; fi;
	elif D = DP then
		if IsInt((Q-1)/P) then return 1; fi;
	elif D = DP2 then
		if IsInt((Q-1)/P^2) then return 1; fi;
	elif D = DP3 then
		if IsInt((Q-1)/P^3) then return 1; fi;
	elif D = DP4 then
		if IsInt((Q-1)/P^4) then return 1; fi;
	elif D = DP5 then
		if IsInt((Q-1)/P^5) then return 1; fi;
	fi;

    return 0;
end;

#############################################################################
##
## Value for porc poly
##
InstallMethod( EvalPNQPorcPoly, [IsPolynomial, IsPosInt, IsPosInt], function( f, P, Q )
    local inds, vals, v, w;
    inds := [p,q,Q2,Q3,Q5,Q13,P2,P3,D1,D2,D3,D4,D5,D6,D7,D8,D9,D10,D11,DP,DP2,DP3,DP4,DP5];
    vals := [P,Q, Val(Q2,P,Q), Val(Q3,P,Q), Val(Q5,P,Q),Val(Q13,P,Q), Val(P2,P,Q), Val(P3,P,Q), 
		     Val(D1,P,Q), Val(D2,P,Q), Val(D3,P,Q), Val(D4,P,Q), Val(D5,P,Q), 
             Val(D6,P,Q), Val(D7,P,Q), Val(D8,P,Q), Val(D9,P,Q), Val(D10,P,Q), Val(D11,P,Q),
			 Val(DP,P,Q), Val(DP2,P,Q), Val(DP3,P,Q), Val(DP4,P,Q), Val(DP5,P,Q)];
    w := Value(f, inds, vals);
    if not IsRat(w) then Error("eval incomplete"); fi;
    return w;
end );

#############################################################################
##
## Simplify porc poly and replace all gcd's
##
SimplifyMyPorcPoly := function( g )
    local D, d, c, i, j, f;

    f := StructuralCopy(g);
    f := Value(f, [q3], [2*D6+1]);
    f := Value(f, [q4], [2*D7+2-Q2]);
    f := Value(f, [q5], [4*D8+1]);
    f := Value(f, [g3], [2*D9+1]);
    f := Value(f, [g4], [2*D10+2]);

    # d^2 = d
    D := [P2, P3, Q2, Q3, D1, D2, D3, D4, D5, D6, D7, D8, D9];
    for d in D do
        c := PolynomialCoefficientsOfPolynomial(f, d);
        f := c[1] + d*Sum(c{[2..Length(c)]});
    od;

    # Q2*Q3 = P2*P3 = P2*Q2 = P3*Q3 = 0
    f := PolynomialReducedRemainder(f, [Q2*Q3], MonomialLexOrdering());
    f := PolynomialReducedRemainder(f, [P2*P3], MonomialLexOrdering());
    f := PolynomialReducedRemainder(f, [P2*Q2], MonomialLexOrdering());
    f := PolynomialReducedRemainder(f, [Q3*P3], MonomialLexOrdering());

    # Q2*D1 = Q2
    f := PolynomialReduction(f, [Q2*D1], MonomialLexOrdering());
    f := f[1] + f[2][1]*Q2;

    # Di*Dj = 0
    D := [D1, D2, D3, D4, D5];
    for i in [1..Length(D)] do
        for j in [i+1..Length(D)] do
            d := D[i]*D[j];
            f := PolynomialReducedRemainder(f, [d], MonomialLexOrdering());
        od;
    od;

    # Q2*Di = 0 for i in [2,3,4,5,6,7,8]
    D := [D2, D3, D4, D5, D6, D7, D8];
    for i in [1..Length(D)] do
        d := Q2*D[i];
        f := PolynomialReducedRemainder(f, [d], MonomialLexOrdering());
    od;

    # q*Q2 = 2*Q2
    repeat
        g := StructuralCopy(f);
        f := PolynomialReduction(g, [q*Q2], MonomialLexOrdering());
        f := f[1] + f[2][1]*2*Q2;
    until f = g;

    return f;
end;
